Index: tools/gdb/python/classic.py
===================================================================
--- tools/gdb/python/classic.py	(revision c3d06d531c497c665671386bc32dd18fbfac49b3)
+++ tools/gdb/python/classic.py	(revision b9ee5df588aa1a4cf0a64cf511b0585309ff5510)
@@ -9,8 +9,11 @@
 import itertools
 import re
+#ToDo This shouldn't be here
+import helper
 
 import objects
 import threads
 import watchdog
+import heaps
 import supercore
 
@@ -42,5 +45,6 @@
         'message_queue' : ['priority',
                            'scope'],
-        'partition' : ['scope']
+        'partition' : ['scope'],
+        'region' : ['priority']
         }
 
@@ -215,5 +219,22 @@
         print '     Attr:', self.attr.to_string()
         print '   Length:', self.length
-        print 'Buffer Size:', self.buffer_size
-        print 'Used Blocks:', self.used_blocks
-
+        print '   B Size:', self.buffer_size
+        print ' U Blocks:', self.used_blocks
+
+class region:
+    "prints a classic region"
+
+    def __init__(self,id):
+        self.id = id
+        self.object = objects.information.object(self.id).dereference()
+        self.object_control = objects.control(self.object['Object'])
+        self.attr = attribute(self.object['attribute_set'], 'region')
+        self.wait_queue = threads.queue(self.object['Wait_queue'])
+        self.heap = heaps.control(self.object['Memory'])
+
+    def show(self, from_tty):
+        print '     Name:', self.object_control.name()
+        print '     Attr:', self.attr.to_string()
+        helper.tasks_printer_routine(self.wait_queue)
+        print '   Memory:'
+        self.heap.show()
Index: tools/gdb/python/heaps.py
===================================================================
--- tools/gdb/python/heaps.py	(revision c3d06d531c497c665671386bc32dd18fbfac49b3)
+++ tools/gdb/python/heaps.py	(revision b9ee5df588aa1a4cf0a64cf511b0585309ff5510)
@@ -16,4 +16,6 @@
         return True
 
+    def val(self):
+        return str(self.block)
 
     def next(self):
@@ -26,8 +28,12 @@
 
 class stats:
-    ''heap statistics''
+    '''heap statistics'''
 
     def __init__(self,stat):
         self.stat = stat
+
+    def inst(self):
+        i = self.stat['instance']
+        return i
 
     def avail(self):
@@ -38,7 +44,12 @@
         return self.stat['free_size']
 
+    def show(self):
+        print '  Instance:',self.inst()
+        print '     Avail:',self.avail()
+        print '      Free:',self.free()
+
     # ToDo : incorporate others
 
-def control:
+class control:
     '''Abstract a heap control structure'''
 
@@ -61,2 +72,13 @@
         st = stats(self.ctl['stats'])
         return st
+
+    def show(self):
+        fi = self.first()
+        la = self.last()
+
+        print '     First:', fi.val()
+        print '      Last:', la.val()
+
+        stats = self.stat()
+        print '    stats:'
+        stats.show()
Index: tools/gdb/python/helper.py
===================================================================
--- tools/gdb/python/helper.py	(revision c3d06d531c497c665671386bc32dd18fbfac49b3)
+++ tools/gdb/python/helper.py	(revision b9ee5df588aa1a4cf0a64cf511b0585309ff5510)
@@ -2,5 +2,5 @@
 # RTEMS GDB support helper routins.
 
-def tasks_printer_rotuine(wait_queue):
+def tasks_printer_routine(wait_queue):
     tasks = wait_queue.tasks()
     print '    Queue: len = %d, state = %s' % (len(tasks),wait_queue.state())
Index: tools/gdb/python/objects.py
===================================================================
--- tools/gdb/python/objects.py	(revision c3d06d531c497c665671386bc32dd18fbfac49b3)
+++ tools/gdb/python/objects.py	(revision b9ee5df588aa1a4cf0a64cf511b0585309ff5510)
@@ -19,5 +19,5 @@
         'classic/message_queues' : ('Message_queue_Control', '_Message_queue_Information'),
         'classic/partitions'     : ('Partition_Control',     '_Partition_Information'),
-        'classic/regions'        : ('Region_Control',        '_Regions_Information'),
+        'classic/regions'        : ('Region_Control',        '_Region_Information'),
         'classic/ports'          : ('Port_Control',          '_Port_Information'),
         'classic/periods'        : ('Period_Control',        '_Period_Information'),
Index: tools/gdb/python/rtems.py
===================================================================
--- tools/gdb/python/rtems.py	(revision c3d06d531c497c665671386bc32dd18fbfac49b3)
+++ tools/gdb/python/rtems.py	(revision b9ee5df588aa1a4cf0a64cf511b0585309ff5510)
@@ -80,5 +80,6 @@
         'classic/message_queues': lambda id: classic.message_queue(id),
         'classic/timers' : lambda id: classic.timer(id),
-        'classic/partitions' : lambda id: classic.partition(id)
+        'classic/partitions' : lambda id: classic.partition(id),
+        'classic/regions' : lambda id: classic.region(id)
         }
 
Index: tools/gdb/python/supercore.py
===================================================================
--- tools/gdb/python/supercore.py	(revision c3d06d531c497c665671386bc32dd18fbfac49b3)
+++ tools/gdb/python/supercore.py	(revision b9ee5df588aa1a4cf0a64cf511b0585309ff5510)
@@ -16,3 +16,3 @@
 
     def show(self):
-        helper.tasks_printer_rotuine(self.wait_queue)
+        helper.tasks_printer_routine(self.wait_queue)
